<template>
  <div>
    <div class="alert alert-info" role="alert">
      Compare, search and filter all the feature changes between two different releases of GitLab.
      <br />
      Data is parsed from
      <a
        href="https://gitlab.com/gitlab-com/www-gitlab-com/-/tree/master/data%2Frelease_posts"
      >
        release posts</a
      >, so only notable improvements are reflected here.
      Consult the <a href="?tab=changelog">CHANGELOG</a> for a more exhaustive list.
    </div>
    <div class="float-right">
      <csv-download
        class="btn btn-primary"
        :array="filteredFeatures"
        :fields="[
          'version',
          'available_in',
          'stage',
          'categories',
          'add_ons',
          'name',
          'description',
          'documentation_link',
          'issue_url',
          'video',
        ]"
        download="features_filtered.csv"
      >
        Export as CSV
      </csv-download>
    </div>
    <div v-if="loading">Loading...</div>
    <template v-else>
      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Introduced after (including)</label>
            <multiselect
              v-model="minVersion"
              :options="allVersions"
              :customLabel="renderVersion"
              :allowEmpty="false"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Introduced before (including)</label>
            <multiselect
              v-model="maxVersion"
              :options="allVersions"
              :customLabel="renderVersion"
              :allowEmpty="false"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Minimum tier</label>
            <multiselect
              v-model="selectedMinTier"
              :options="allTiers"
              placeholder="Select a minimum tier"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Maximum tier</label>
            <multiselect
              v-model="selectedMaxTier"
              :options="allTiers"
              placeholder="Select a maximum tier"
            />
          </div>
          <div class="form-group col-md-2"
               data-toggle="tooltip"
               data-placement="top"
               title="Limit results to availability in specific GitLab distributions.">
            <label>SaaS / self-managed availability</label>
            <multiselect
              v-model="selectedSaaS"
              :options="saasOptions"
              placeholder="Select availability"
            />
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-md-3">
            <label>Stage</label>
            <multiselect
              v-model="selectedStages"
              :options="allStages"
              :multiple="true"
              placeholder="Select one or multiple stages"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Category</label>
            <multiselect
              v-model="selectedCategories"
              :options="allCategories"
              :multiple="true"
              placeholder="Select one or multiple categories"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Add-On</label>
            <multiselect
              v-model="selectedAddons"
              :options="allAddons"
              :multiple="true"
              placeholder="Select one or multiple Add-On"
            />
          </div>
        </div>
        <div class="form-row">
          <div class="form-group col-md2">
            <div class="form-check">
              <input
                class="form-check-input"
                type="checkbox"
                v-model="onlyKeyImprovements"
                id="onlyKeyImprovementsCheck"
              />
              <label class="form-check-label" for="onlyKeyImprovementsCheck">
                Show only key improvements highlighted in release notes
              </label>
            </div>
          </div>
        </div>
        <div class="form-row">
          <div
            class="form-group col-md-3"
            data-toggle="tooltip"
            data-placement="top"
            title="Search supports regular expressions."
          >
            <label>Fulltext search</label>
            <input
              class="form-control"
              placeholder="Search feature name and description"
              v-model="textSearch"
            />
          </div>
          <div class="form-group col-md-3">
            <label>Order By</label><br />
            <div class="btn-group" role="group" aria-label="Basic example">
              <select class="custom-select" v-model="orderKey">
                <option value="version">Version</option>
              </select>
              <button
                type="button"
                @click="order = order * -1"
                class="btn btn-outline-dark"
              >
                {{ order < 0 ? "Asc" : "Desc" }}
              </button>
            </div>
          </div>
        </div>
      </form>
      <paginated-table
        :items="filteredFeatures"
        :total-items="features.length"
        :per-page-default="500"
      >
        <template v-slot:header>
          <tr>
            <th>Version</th>
            <th>Tier</th>
            <th>Stage</th>
            <th>Categories</th>
            <th>Add-Ons</th>
            <th>Description</th>
            <th>Links</th>
          </tr>
        </template>
        <template v-slot:row="{ item: feature }">
          <td>{{ renderVersion(feature.version.replace(/_0?/, ".")) }}</td>
          <td>{{ (feature.available_in || []).join(", ") }}</td>
          <td>{{ feature.stage }}</td>
          <td>{{ (feature.categories || []).join(", ") }}</td>
          <td>{{ (feature.add_ons || []).join(", ") }}</td>
          <td>
            <strong><a :href="feature.deeplink" target="_blank">{{ feature.name }}</a></strong
            ><br /><span v-html="feature.description"></span>
          </td>
          <td>
            <a
              v-if="feature.documentation_link"
              :href="feature.documentation_link"
              >Documentation</a>
              <br />
            <span v-for="feature in feature.issue_url">
              <a :href="feature">Issue</a>
              <br />
            </span>
            <a v-if="feature.video" :href="feature.video">Video</a>
          </td>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import Multiselect from "vue-multiselect";
import PaginatedTable from "./components/paginated-table.vue";
import CsvDownload from "./components/csv-download.vue";

const uniqAndSort = (array) => {
  return Array.from(new Set(array)).filter(Boolean).sort();
};

const allTiersWithValue = [
  {
    name: "core",
    value: 10,
  },
  {
    name: "starter",
    value: 20,
  },
  {
    name: "premium",
    value: 30,
  },
  {
    name: "ultimate",
    value: 40,
  },
];

let searchDefaults = {
  order: 1,
  orderKey: "version",
  selectedAddons: [],
  selectedCategories: [],
  selectedStages: [],
  textSearch: "",
  minVersion: null,
  maxVersion: null,
  selectedMinTier: "",
  selectedMaxTier: "",
  onlyKeyImprovements: false,
  selectedSaaS: null
};

function eqSet(as, bs) {
  if (as.length !== bs.length) return false;
  for (let a of as) if (!bs.includes(a)) return false;
  return true;
}

export default {
  components: {
    CsvDownload,
    PaginatedTable,
    Multiselect,
  },
  data() {
    return {
      data: [],
      loading: true,
      ...searchDefaults,
    };
  },
  async mounted() {
    const response = await fetch("./features.json");

    this.data = await response.json();
    const params = new URLSearchParams(window.location.search);

    searchDefaults.minVersion = this.allVersions[0];
    searchDefaults.maxVersion = this.allVersions.slice(-1)[0];

    this.minVersion = searchDefaults.minVersion;
    this.maxVersion = searchDefaults.maxVersion;

    Object.entries(searchDefaults).forEach(([key, value]) => {
      if (Array.isArray(value)) {
        const newVal = params.getAll(key);
        if (!eqSet(newVal, value)) {
          this[key] = newVal;
        }
        return;
      }

      const newVal = params.get(key);

      if (newVal && newVal !== value) {
        this[key] = newVal;
      }
    });
    this.$parent.pageView({ page: "features" });
    this.loading = false;
  },
  updated() {
    const params = new URLSearchParams();
    Object.entries(searchDefaults).forEach(([key, value]) => {
      let newVal = this[key];

      if (Array.isArray(value)) {
        if (!eqSet(newVal, value)) {
          newVal.forEach((x) => {
            params.append(key, x);
          });
        }
        return;
      }

      if (newVal && newVal !== value) {
        params.set(key, newVal);
      }
      params.set("tab", "features");
    });
    window.history.replaceState(
      {},
      "",
      window.location.protocol +
        "//" +
        window.location.host +
        window.location.pathname +
        "?" +
        params.toString()
    );
  },
  methods: {
    renderVersion(version) {
      return version.replace(/^0/, "").replace(/_0?/, ".");
    }
  },
  computed: {
    allAddons() {
      return uniqAndSort(
        this.features.map((feature) => feature.add_ons).flat()
      );
    },
    allCategories() {
      return uniqAndSort(
        this.features.map((feature) => feature.categories).flat()
      );
    },
    allVersions() {
      return uniqAndSort(
        this.features.map((feature) => feature.version).flat()
      );
    },
    allStages() {
      return uniqAndSort(this.features.map((feature) => feature.stage).flat());
    },
    allTiers() {
      return Object.values(allTiersWithValue).map((x) => x.name);
    },
    searchLower() {
      return this.textSearch.toLocaleLowerCase();
    },
    saasOptions() {
      return ["GitLab.com available","GitLab.com only","Dedicated available","Dedicated only","self-managed available","self-managed only"]
    },
    features() {
      return this.data.map((feature) => {
        const { available_in, ...rest } = feature;

        const tiers = (available_in || ['core']).map((x) => {
          switch (x) {
            case "bronze":
              return "starter";
            case "silver":
              return "premium";
            case "gold":
              return "ultimate";
            case "free":
              return "core";
            default:
              return x;
          }
        });

        if(typeof rest.issue_url === "string") {
          rest.issue_url = [rest.issue_url]
        }

        const minTier = allTiersWithValue.find((x) => tiers.includes(x.name))
          .value;

        return {
          verbatim_tiers: available_in,
          available_in: tiers,
          minTier,
          ...rest,
          id: rest.version + rest.name,
        };
      });
    },
    filteredFeatures() {
      return this.features
        .filter((feature) => {
          let visible = true;
          if (visible && this.maxVersion) {
            visible = visible && feature.version <= this.maxVersion;
          }

          if (visible && this.minVersion) {
            visible = visible && feature.version >= this.minVersion;
          }

          if (visible && this.selectedStages.length) {
            visible =
              visible && this.selectedStages.includes(feature.stage || null);
          }

          if (visible && this.selectedMinTier) {
            visible =
              visible &&
              feature.minTier >=
                allTiersWithValue.find((x) => x.name === this.selectedMinTier)
                  .value;
          }

          if (visible && this.selectedMaxTier) {
            visible =
              visible &&
              feature.minTier <=
                allTiersWithValue.find((x) => x.name === this.selectedMaxTier)
                  .value;
          }

          if (visible && this.selectedSaaS) {
            const saas_tiers = ["free","bronze","silver","gold"]
            var sm_only = (feature.gitlab_com === false) && (this.selectedSaaS == "self-managed only")
            console.log(feature)
            // experimental features have no metadata, so when we filter on distribution, they should be filtered out
            if(feature.verbatim_tiers) {
              var saas_only = (feature.verbatim_tiers.some(r=> saas_tiers.includes(r))) && (this.selectedSaaS == "GitLab.com only")
              var sm_available = !(feature.verbatim_tiers.some(r=> saas_tiers.includes(r))) && (this.selectedSaaS == "self-managed available")
              var dedicated_only = (feature.gitlab_com === false) && (this.selectedSaaS == "Dedicated only")
              var dedicated_available = !(feature.verbatim_tiers.some(r=> saas_tiers.includes(r))) && (this.selectedSaaS == "Dedicated available")
              var saas_available = ((feature.gitlab_com === true) || (feature.verbatim_tiers.some(r=> saas_tiers.includes(r)))) && (this.selectedSaaS == "GitLab.com available")
              visible =
                visible &&
                (sm_only || saas_only || sm_available || saas_available || dedicated_only || dedicated_available);
            } else {
              visible = false
            }
          }

          if (visible && this.selectedCategories.length) {
            visible =
              visible &&
              (feature.categories || []).some((c) =>
                this.selectedCategories.includes(c)
              );
          }

          if (visible && this.selectedAddons.length) {
            visible =
              visible &&
              (feature.add_ons || []).some((c) =>
                this.selectedAddons.includes(c)
              );
          }

          if(visible && this.onlyKeyImprovements) {
            visible = visible && (feature.rank === "top" || feature.rank === "primary");
          }

          if (visible && this.textSearch) {
            const regex = new RegExp(this.searchLower, "gi");
            visible =
              visible &&
              (feature.name.toLocaleLowerCase().includes(this.searchLower) ||
                feature.description
                  .toLocaleLowerCase()
                  .includes(this.searchLower) ||
                feature.description.toLocaleLowerCase().match(regex));
          }

          return visible;
        })
        .sort((a, b) => {
          const valA = a[this.orderKey];
          const valB = b[this.orderKey];

          if (valA === valB) {
            return 0;
          }

          return (valB < valA ? -1 : 1) * this.order;
        });
    },
  },
};
</script>
